include <library.scad>

$fn = 64;

tolerance = 0.15;

module thrust_bearing() {
	difference() {
		rotate_extrude() thrust_bearing_inner_profile(-tolerance);
		mirror([0, 0, 1]) vslots_z_negative_bevelled();
	}

	difference() {
		translate([0, 0, -unit/2]) cylinder(unit/2-tolerance, d=unit);
		rotate_extrude() thrust_bearing_inner_profile(tolerance);
		vslots_z_negative_bevelled();
	}
}

module thrust_bearing_inner_profile(offset) polygon([
	[0, unit/2],
	[unit/2, unit/2],
	[unit/2+offset, 0],
	[2+offset, 2-unit/2],
	[2+offset, 1-unit/2],
	[3+offset, -unit/2],
	[0, -unit/2],
]);

// module hinge() {
// 	difference() {
// 		rotate(90, [1, 0, 0]) linear_extrude(slot_separation, center=true) {
// 			circle(d=slot_separation);
// 			translate([-unit/2, -slot_separation/2]) square([slot_clip_length+slot_lip+slot_separation/2, slot_separation]);
// 		}
// 		translate([slot_clip_length+slot_lip-unit/2, -slot_separation/4-tolerance, -unit/2]) cube([unit, slot_separation/2+tolerance*2, unit]);
// 	}
// 	for (y = [0, 1]) mirror([0, y, 0]) {
// 		translate([0, -slot_separation/4-tolerance, 0]) rotate(-90, [1, 0, 0]) cylinder(slot_separation/2, d1=slot_separation, d2=0);
// 	}
// 
// 	translate([unit/2-slot_clip_length-slot_lip, -slot_separation/2, -slot_separation/2]) cube([slot_clip_length+slot_lip, slot_separation, slot_separation]);
// }

// module hinge() {
// 	difference() {
// 		union() {
// 			translate([0, 0, slot_lip_fudge-slot_separation/2]) linear_extrude(slot_separation/2-tolerance-slot_lip_fudge) hinge_outside();
// 			translate([-unit/2, -slot_separation/2, slot_lip_fudge-slot_separation/2]) cube([slot_clip_length+slot_lip, slot_separation, slot_separation-slot_lip_fudge]);
// 		}
// 		translate([0, 0, -slot_separation/2]) cylinder(slot_separation/2, d=slot_separation/4+tolerance*2);
// 		translate([0, 0, slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/4, d1=slot_separation/2+tolerance*2, d2=tolerance*2);
// 		translate([0, 0, slot_separation/8+slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/2, d1=tolerance*2, d2=slot_separation+tolerance*2);
// 	}
// 
// 	translate([0, 0, slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/2, d=slot_separation/4-tolerance*2);
// 	translate([0, 0, slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/4, d1=slot_separation/2-tolerance*2, d2=0);
// 	intersection() {
// 		cylinder_height = slot_separation-slot_separation/8-slot_lip_fudge;
// 		translate([0, 0, slot_separation/8+slot_lip_fudge-slot_separation/2]) cylinder(cylinder_height, d1=0, d2=cylinder_height*2-tolerance*2);
// 		linear_extrude(unit, center=true) rotate(180) hinge_outside();
// 	}
// 	translate([unit/2-slot_clip_length-slot_lip, -slot_separation/2, slot_lip_fudge-slot_separation/2]) cube([slot_clip_length+slot_lip, slot_separation, slot_separation-slot_lip_fudge]);
// 	translate([0, 0, slot_separation*3/8]) linear_extrude(slot_separation/8) mirror([1, 0]) hinge_outside();
// }

module hinge() difference() {
	union() {
		difference() {
			translate([0, 0, slot_lip_fudge-slot_separation/2]) linear_extrude(slot_separation-slot_lip_fudge) hinge_outside();
			hinge_inside(tolerance);
		}
		translate([-unit/2, -slot_separation/2, slot_lip_fudge-slot_separation/2]) cube([slot_clip_length+slot_lip, slot_separation, slot_separation-slot_lip_fudge]);

		translate([0, 0, slot_separation*0.83-slot_separation/2]) linear_extrude(slot_separation*0.17) mirror([1, 0]) hinge_outside();
		translate([unit/2-slot_clip_length-slot_lip, -slot_separation/2, slot_lip_fudge-slot_separation/2]) cube([slot_clip_length+slot_lip, slot_separation, slot_separation-slot_lip_fudge]);
		intersection() {
			hinge_inside(-tolerance);
			linear_extrude(unit, center=true) rotate(180) hinge_outside();
		}
	}

	vslots_x_negative();
	vslots_x_positive();
}

module hinge_inside(offset) {
	translate([0, 0, slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/2, d=slot_separation/4+offset*2);
	translate([0, 0, slot_lip_fudge-slot_separation/2]) cylinder(slot_separation/4+offset, d1=slot_separation/2+offset*2, d2=0);
	cylinder_height = slot_separation-slot_separation/8-slot_lip_fudge+offset;
	translate([0, 0, slot_separation/8+slot_lip_fudge-slot_separation/2-offset]) cylinder(cylinder_height, d1=0, d2=cylinder_height*2+offset*2);
}

module hinge_outside() hull() {
	translate([-unit/2, -slot_separation/2]) square([slot_clip_length+slot_lip, slot_separation]);
	circle(d=slot_separation-tolerance*2);
}

thrust_bearing();
translate([grid, 0, 0]) hinge();
